"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.p2pFragmentLoader = void 0;
const hls_js_1 = __importStar(require("hls.js"));
const marecchia_core_1 = __importStar(require("@marecchia/marecchia-core"));
exports.default = marecchia_core_1.default;
function p2pFragmentLoader(stream_id) {
    return class P2PFragmentLoader {
        p2pNetwork;
        httpLoader;
        context;
        stats;
        constructor(confg) {
            this.p2pNetwork = (0, marecchia_core_1.new_p2p_client)(stream_id);
            this.httpLoader = new hls_js_1.default.DefaultConfig.loader(confg).load;
            this.stats = new hls_js_1.LoadStats();
            this.context = null;
        }
        load(context, config, callbacks) {
            const segmentId = context.frag.sn.toString();
            // P2P exchanges only complete segments (no byte range support)
            context.rangeStart = undefined;
            context.rangeEnd = undefined;
            const segment_promise = this.p2pNetwork.request_segment(segmentId);
            const timeout_promise = new Promise((_resolve, reject) => {
                const timeout = setTimeout(() => {
                    clearTimeout(timeout);
                    reject(new Error("Segment request timed out"));
                }, 5000);
            });
            Promise.race([segment_promise, timeout_promise])
                .then((segment) => {
                callbacks.onSuccess({
                    url: `p2p://${segmentId}`,
                    data: segment,
                }, this.stats, context, null);
            })
                .catch((_) => {
                // Custom callbacks to upload a new segment once is downloaded from the server
                const http_callbacks = {
                    ...callbacks,
                    onSuccess: (response, stats, context, networkDetails) => {
                        if (response.code && response.code === 200 && response.data && response.data instanceof ArrayBuffer) {
                            let data = new Uint8Array(response.data);
                            this.p2pNetwork.send_segment(segmentId, data);
                        }
                        callbacks.onSuccess(response, stats, context, networkDetails);
                    }
                };
                // Load the segment using the default HTTP loader
                this.httpLoader(context, config, http_callbacks);
            });
        }
        destroy() {
            this.p2pNetwork.quit();
        }
        abort() {
            this.destroy();
        }
    };
}
exports.p2pFragmentLoader = p2pFragmentLoader;
//# sourceMappingURL=index.js.map